c-----------------------------------------------------------------------
c	This subroutine computes log predictive error of all NN architectures
c-----------------------------------------------------------------------
      subroutine archcomp
	INCLUDE 'header.txt'

	real elpmax
	farchi(1:30,1:5)=0.0
	farchiwtih(1:30,1:10,1:30)=0.0
	farchiwtho(1:30,1:30,1:10)=0.0
	farchiwtbh(1:30,1:30)=0.0
	fhyperpara(1:30,1:2)=0.0
	ferrdat(1:30)=0.0
	elp(1:30)=0.0
	j=0

	do 5 i=1,nnetwork
		if(archi(i,3).le.err_thresh)then
			j=j+1
			farchi(j,1:3)=archi(i,1:3)
			fhyperpara(j,1:2)=hyperpara(i,1:2)
			farchiwtih(j,1:nip,1:nhid)=archiwtih(i,1:nip,1:nhid)
			farchiwtho(j,1:nhid,1:nop)=archiwtho(i,1:nhid,1:nop)
			farchiwtbh(j,1:nhid)=archiwtbh(i,1:nhid)
			ferrdat(j)=errdat(i)
		endif
 5    continue

C	Calculation of LPE for all networks 	
      jfinnet=j
      do 10 i=1,jfinnet      
		elp(i)=0.5*fhyperpara(i,2)*ferrdat(i)
     1		   +(ntrndat)*log(sqrt(2*3.14/(fhyperpara(i,2))))
 10   continue     
C	Comparing LPE of all networks for selection
      elpmax=elp(1)
      nhid=farchi(1,1)      
      do 15 icounter = 2,jfinnet
		if (elpmax.gt.elp(icounter)) then
			elpmax=elp(icounter)
			nhid=farchi(icounter,1)
		endif
 15   continue    
C	Storing values of wts & hyperparameters of selected network in resp. arrays       
      do 25 j=1,jfinnet     
		if(farchi(j,1).eq.nhid)then
			wtih(1:nip,1:nhid)=farchiwtih(j,1:nip,1:nhid)
			wtho(1:nhid,1:nop)=farchiwtho(j,1:nhid,1:nop)
			wtbh(1:nhid)=farchiwtbh(j,1:nhid)
			alpha1=fhyperpara(j,1)
			beta=fhyperpara(j,2)
		endif
 25   continue
 	nwtih=nip*nhid
      nwtho=nhid*nop
      if(nadbias.eq.1)then
		nwtbh=nhid
	else
		nwtbh=0
      endif
      nwts=nwtbh+nwtih+nwtho   

C	Storing attributes of selected network to a specified file 
      if((nopfl.eq.1).OR.(nopfl.eq.2))then
      	write(13,*)nhid,nwts,nadbias,nbias
		write(13,*)
		write(13,*)bias
		write(13,*)
		write(13,*)eta,alpha
		write(13,*)
		write(13,*)znrm1,znrm2
		write(13,*)
		write(13,*)lscale
		write(13,*)
		write(13,9)wtbh(1:nhid)
		write(13,*)
		do 40 i=1,nip
			write(13,9)wtih(i,1:nhid)
40		continue   
		write(13,*) 
		do 45 i=1,nhid
			write(13,9)wtho(i,1:nop)
45		continue  
		write(13,*)
		write(13,*)alpha1
		write(13,*)
		write(13,*)beta
		write(13,*)
      endif

  9   format(<nwts>(F10.5,1x))       	           
200   return
	end