c--------------------------------------------------------------------------
c     This subroutine predicts the output and corresponding error bars for
c     the training data set
c--------------------------------------------------------------------------
      SUBROUTINE trainerrbar
      INCLUDE 'header.txt'               

      dimension testsum(2,50),testact(2,50),testdact(2,50)
      dimension testddact(2,50),tempmat(500,500),tempvar(nop,500)
      dimension actval(nop),derr(nop),ebar(2,nop),preddev(2,nop)
      real alphaold,betaold,delta,propsum1,propsum2,temp,wtsum       
      actval(1:nop)=0.0
      ebar(1:2,1:nop)=0.0
      tempmat(1:500,1:500)=0.0
      tempvar(1:nop,1:100)=0.0
      testsum(1:2,1:50)=0.0
      testact(1:2,1:50)=0.0
      testdact(1:2,1:50)=0.0
      testddact(1:2,1:50)=0.0
      coef=0.0
      delta=0.0

      open(41,file='training_output.txt',status="replace")
	write(41,17)"Dataset","Input Columns=",nip,"Desired","Predicted",
	1			"UpperBound","LowerBound"
      write(41,*)  
      
	do 5 ii=1,ntrndat        
         im=1
         derr(1:nop)=0.0
         grad(1:5,1:100)=0.0
         predvar(1:5)=0.0   
         preddev(1:2,1:nop)=0.0
         tempvar(1:nop,1:nwts)=0.0
         testsum(1:2,1:50)=0.0
         testact(1:2,1:50)=0.0
         testdact(1:2,1:50)=0.0       
         do 15 ij=1,nhid        
            testsum(1,ij)=bias*wtbh(ij)+
     1      sum(wtih(1:nip,ij)*xnorm(ii,1:nip))
	      testact(1,ij)=(exp(testsum(1,ij))-exp(-testsum(1,ij)))
     1	                 /(exp(testsum(1,ij))+exp(-testsum(1,ij)))
		    testdact(1,ij)=1-(testact(1,ij)*testact(1,ij))
 15      continue
	   do 20 ij=1,nop
	      testsum(2,ij)=sum(wtho(1:nhid,ij)*testact(1,1:nhid))
		    testact(2,ij)=(exp(testsum(2,ij))-exp(-testsum(2,ij)))
     1	                 /(exp(testsum(2,ij))+exp(-testsum(2,ij)))
		    testdact(2,ij)=1-(testact(2,ij)*testact(2,ij))
 20      continue      
         if (nadbias.eq.1.0) then
            do 10 ir=1,nbias               !gradient for bias-hid
               do 10 ic=1,nhid                
                  grad(1:nop,im)=grad(1:nop,im)+testdact(1,ic)
     1                  *bias*(testdact(2,1:nop)*wtho(ic,1:nop))
                  im=im+1              
 10         continue
         endif      
         do 25 ir=1,nip                         !gradient for inp-hid
            do 25 ic=1,nhid                
               grad(1:nop,im)=grad(1:nop,im)+testdact(1,ic)
     1                  *xnorm(ii,ir)*(testdact(2,1:nop)*wtho(ic,1:nop))
               im=im+1              
 25      continue
         do 40 ir=1,nhid                   !gradient for hid-op
            do 40 ic=1,nop                
               do 55 jj=1,nop         
                  if (jj.eq.ic)then  
                     grad(jj,im)=grad(jj,im)+testdact(2,ic)
     1                           *testact(1,ir)
                  else
                     grad(jj,im)=0.0
                  endif        
 55            continue
               im=im+1
 40      continue   
         do 60 ir=1,nwts
            do 60 ic=1,nwts        
               tempvar(1:nop,ir)=tempvar(1:nop,ir)+
     1                           ahessianinv(ir,ic)*grad(1:nop,ic)
 60      continue          
         do 65 ic=1,nwts        
            predvar(1:nop)=predvar(1:nop)+tempvar(1:nop,ic)
     1                     *grad(1:nop,ic)      
 65      continue   
         preddev(1,1:nop)=testact(2,1:nop)
     1                      +(sqrt((1.0/beta)+predvar(1:nop)))
         preddev(2,1:nop)=testact(2,1:nop)
     1                      -(sqrt((1.0/beta)+predvar(1:nop)))
         ebar(1,1:nop)=rop(1:nop,1)+((preddev(1,1:nop)-znrm1)
     1                  *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)     
         ebar(2,1:nop)=rop(1:nop,1)+((preddev(2,1:nop)-znrm1)
     1                  *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)     
         actval(1:nop)=rop(1:nop,1)+((testact(2,1:nop)-znrm1)
     1                  *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)     
         if (lscale.eq.1) then
            ebar(1,1:nop)=EXP(ebar(1,1:nop))
            ebar(2,1:nop)=EXP(ebar(2,1:nop))
            actval(1:nop)=EXP(actval(1:nop))
         endif
         if (lscale.eq.1) then 
            write(41,12)ii,xip(ii,1:nip),EXP(yop(ii,1:nop)),
	1			      actval(1:nop),ebar(1,1:nop),ebar(2,1:nop)
	   else
	      write(41,12)ii,xip(ii,1:nip),(yop(ii,1:nop)),
	1			      actval(1:nop),ebar(1,1:nop),ebar(2,1:nop)
	   endif	
 5    continue      
 12   format(I5,1x,<nip+nop>(F10.3,1x),1x,<3>(F10.3,1x))
 17   format(A10,2X,A16,I2,2X,A10,2X,A10,2X,A10,2x,A10) 
      close(41)
      return
      END SUBROUTINE trainerrbar
c-----------------------------------------------------------------------
c     This subroutine predicts the output and corresponding error bars for
c     the testing data set
c--------------------------------------------------------------------------

      SUBROUTINE testpred
      INCLUDE 'header.txt'        
        
      dimension testsum(2,50),testact(2,50)
      dimension testdact(2,50),testddact(2,50)
      dimension tempmat(500,500),tempvar(nop,500)
      dimension derr(nop)
      dimension preddev(2,nop),ebar(2,nop)
      dimension actval(nop)
      real alphaold,betaold,delta,propsum1,propsum2,temp,wtsum     
      actval(1:nop)=0.0
      ebar(1:2,1:nop)=0.0
      preddev(1:2,1:nop)=0.0
      testsum(1:2,1:50)=0.0
      testact(1:2,1:50)=0.0
      testdact(1:2,1:50)=0.0
      testddact(1:2,1:50)=0.0
      tempmat(1:500,1:500)=0.0
      tempvar(1:nop,1:100)=0.0
      delta=0.0
      coef=0.0            

      open(41,file='testing_output.txt',status="replace")
      write(41,17)"Dataset","Input Columns=",nip,"Desired","Predicted",
	1			"UpperBound","LowerBound"
      write(41,*) 
        
      do 5 ii=1,ntstdat       
       im=1
       testsum(1:2,1:50)=0.0
       testact(1:2,1:50)=0.0
       testdact(1:2,1:50)=0.0
       grad(1:5,1:100)=0.0
       derr(1:nop)=0.0
       tempvar(1:nop,1:nwts)=0.0   
       predvar(1:5)=0.0         
        
      do 15 ij=1,nhid        
        testsum(1,ij)=bias*wtbh(ij)+
     1                sum(wtih(1:nip,ij)*testip(ii,1:nip))
	  testact(1,ij)=(exp(testsum(1,ij))-exp(-testsum(1,ij)))
     1               /(exp(testsum(1,ij))+exp(-testsum(1,ij)))
	  testdact(1,ij)=1-(testact(1,ij)*testact(1,ij))
 15   continue
	do 20 ij=1,nop
	  testsum(2,ij)=sum(wtho(1:nhid,ij)*testact(1,1:nhid))
	  testact(2,ij)=(exp(testsum(2,ij))-exp(-testsum(2,ij)))
     1               /(exp(testsum(2,ij))+exp(-testsum(2,ij)))
	  testdact(2,ij)=1-(testact(2,ij)*testact(2,ij))
 20   continue      
 
        if (nadbias.eq.1.0) then
         do 10 ir=1,nbias          !grad. for bias-hid.
            do 10 ic=1,nhid                
               grad(1:nop,im)=grad(1:nop,im)+testdact(1,ic)
     1                  *bias*(testdact(2,1:nop)*wtho(ic,1:nop))
               im=im+1              
 10      continue
      endif
      
      do 25 ir=1,nip          !grad. for inp.-hid
         do 25 ic=1,nhid                
            grad(1:nop,im)=grad(1:nop,im)+testdact(1,ic)
     1         *testip(ii,ir)*(testdact(2,1:nop)*wtho(ic,1:nop))     
            im=im+1              
 25      continue

         do 40 ir=1,nhid        !grad. for hd.-op.
            do 40 ic=1,nop                
               do 55 jj=1,nop         
                  if (jj.eq.ic)then  
                     grad(jj,im)=grad(jj,im)+testdact(2,ic)
     1                           *testact(1,ir)
                  else
                     grad(jj,im)=0.0
                  endif        
 55           continue 
              im=im+1              
 40      continue   
       
         do 60 ir=1,nwts
            do 60 ic=1,nwts        
               tempvar(1:nop,ir)=tempvar(1:nop,ir)
     1                    +ahessianinv(ir,ic)*grad(1:nop,ic)
 60      continue   
 
         do 65 ic=1,nwts        
            predvar(1:nop)=predvar(1:nop)+tempvar(1:nop,ic)
     1                    *grad(1:nop,ic)        
 65      continue   

         preddev(1,1:nop)=testact(2,1:nop)
     1                   +(sqrt((1.0/beta)+predvar(1:nop)))      
         preddev(2,1:nop)=testact(2,1:nop)
     1                   -(sqrt((1.0/beta)+predvar(1:nop)))      
         ebar(1,1:nop)=rop(1:nop,1)+((preddev(1,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)      
         ebar(2,1:nop)=rop(1:nop,1)+((preddev(2,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)      
         actval(1:nop)=rop(1:nop,1)+((testact(2,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)
     
        if (lscale.eq.1 )then
           ebar(1,1:nop)=exp(ebar(1,1:nop))
           ebar(2,1:nop)=exp(ebar(2,1:nop))
           actval(1:nop)=exp(actval(1:nop))
        endif
        
        write(41,12)ii,atestip(ii,1:nip),testop(ii,1:nop),
	1			   actval(1:nop),ebar(1,1:nop),ebar(2,1:nop)
 5    continue      
 12   format(I5,1x,<nip+nop>(F10.3,1x),1x,<3>(F10.3,1x))
 17   format(A10,2X,A16,I2,2X,A10,2X,A10,2X,A10,2x,A10)
      close(41)
      return
      END SUBROUTINE testpred
c-------------------------------------------------------------------------
c     This subroutine finds out the prediction and corresponding
c     uncertaintites for a unknown set of input data. Currently,
c     the unknown data set is created internally within the range
c     of iput variables 
c-------------------------------------------------------------------------      
      SUBROUTINE unknownpred     
      INCLUDE 'header.txt'
      
	dimension testsum(2,50),testact(2,50),testdact(2,50)
      dimension testddact(2,50),tempmat(500,500),tempvar(nop,500)
      dimension actval(nop),derr(nop),ebar(2,nop),preddev(2,nop)
      real alphaold,betaold,delta,propsum1,propsum2,temp,wtsum
      integer idiv,ict
      real iprod
      actval(1:nop)=0.0
      ebar(1:2,1:nop)=0.0
      preddev(1:2,1:nop)=0.0
      tempmat(1:500,1:500)=0.0  
      tempvar(1:nop,1:100)=0.0
      testsum(1:2,1:50)=0.0
      testact(1:2,1:50)=0.0
      testdact(1:2,1:50)=0.0
      testddact(1:2,1:50)=0.0
      coef=0.0
      delta=0.0  
      prednorm(1:15000,1:10)=0.0
	predip(1:15000,1:10)=0.0
	i_inc(1:10,1:2)=1    
	open(41,file='newdata_output.txt',status="replace")
      

	if (nsel.eq.0)then
		call reread
	endif
	
C     COMPARING RANGE OF TRAINING AND PREDICTION DATA--------
      
      do 115 i=1,nip
		if((prip(i,1).lt.(rip(i,1))).OR.(prip(i,2).gt.(rip(i,2))))then
			write(*,*)"Data out of training range - generation aborting"
			pause
			go to 100
		end if 
115   continue
	
C     GENERATION OF DATA--------------------------------------
	
	do 75 ii=1,nip
		i_inc(ii,1)=floor((prip(ii,2)-prip(ii,1))/prip_range(ii))+1
 75   continue
 
      iprod=1
      do 80 ij=1,nip
		idata=iprod*(i_inc(ij,1))
		iprod=idata
80    continue     

      do 85 ia=1,nip
		iprod=1
		do 90 ib=(ia+1),nip
			i_inc(ia,2)=iprod*(i_inc(ib,1))
			iprod=i_inc(ia,2)
90		continue          
85    continue        	
      
      if (idata.gt.15000) then
         write(*,*)"No. of data (",idata,") > array size = 15000"
         write(*,*)"Generation aborting"
         pause 
         go to 100
      endif
        
      do 95 ic=1,nip
		idiv=0
		ict=0
		do 105 id=1,idata       
			ict=ict+1
			predip(id,ic)=prip(ic,1)+idiv*prip_range(ic)
			idiv=(ict/(i_inc(ic,2)))       
			if(idiv.eq.i_inc(ic,1))then
				idiv=0
				ict=0
			endif                         
105		continue
95    continue
	
      do 110 i=1,idata
	  do 110 j=1,nip
	  prednorm(i,j)=znrm1+((predip(i,j)-rip(j,1))/(rip(j,2)-rip(j,1)))
     1					 *(znrm2-znrm1)
110   continue

c     PREDICTION FOR GENERATED DATA---------------------------------
      write(41,17)"Dataset","Input Columns=",nip,"Predicted",
	1			"UpperBound","LowerBound"
      write(41,*)         
      do 5 ii=1,idata
         im=1
         grad(1:5,1:100)=0.0
         derr(1:nop)=0.0
         predvar(1:5)=0.0
         testsum(1:2,1:50)=0.0
         testact(1:2,1:50)=0.0
         testdact(1:2,1:50)=0.0     
            
         do 15 ij=1,nhid        
            testsum(1,ij)=bias*wtbh(ij)+
     1      sum(wtih(1:nip,ij)*prednorm(ii,1:nip))
		    testact(1,ij)=(exp(testsum(1,ij))-exp(-testsum(1,ij)))
     1					 /(exp(testsum(1,ij))+exp(-testsum(1,ij)))
		    testdact(1,ij)=1-(testact(1,ij)*testact(1,ij))
 15      continue
 
	   do 20 ij=1,nop
		    testsum(2,ij)=sum(wtho(1:nhid,ij)*testact(1,1:nhid))
		    testact(2,ij)=(exp(testsum(2,ij))-exp(-testsum(2,ij)))
     1					/(exp(testsum(2,ij))+exp(-testsum(2,ij)))
	      testdact(2,ij)=1-(testact(2,ij)*testact(2,ij))
 20      continue                     
         if (nadbias.eq.1.0) then
             do 10 ir=1,nbias       !grad. for bias-hid
                do 10 ic=1,nhid                
                   grad(1:nop,im)=grad(1:nop,im)+testdact(1,ic)
     1                  *bias*(testdact(2,1:nop)*wtho(ic,1:nop))
                im=im+1              
 10          continue
         endif      
         do 25 ir=1,nip         !grad. for inp-hid.
            do 25 ic=1,nhid                
               grad(1:nop,im)=grad(1:nop,im)+testdact(1,ic)
     1         *prednorm(ii,ir)*(testdact(2,1:nop)*wtho(ic,1:nop))
               im=im+1              
 25      continue
         do 40 ir=1,nhid           ! gard. for inp=hd
            do 40 ic=1,nop                
               do 55 jj=1,nop         
                  if (jj.eq.ic)then  
                     grad(jj,im)=grad(jj,im)+testdact(2,ic)
     1                           *testact(1,ir)
                  else
                     grad(jj,im)=0.0
                  endif        
 55            continue
               im=im+1
 40      continue        
         tempvar(1:nop,1:nwts)=0.0
         do 60 ir=1,nwts
            do 60 ic=1,nwts        
               tempvar(1:nop,ir)=tempvar(1:nop,ir)
     1                    +ahessianinv(ir,ic)*grad(1:nop,ic) 
 60      continue   
        
         do 65 ic=1,nwts        
            predvar(1:nop)=predvar(1:nop)+tempvar(1:nop,ic)
     1                     *grad(1:nop,ic)  
 65      continue
         
         preddev(1,1:nop)=testact(2,1:nop)
     1                   +(sqrt((1.0/beta)+predvar(1:nop)))
         preddev(2,1:nop)=testact(2,1:nop)
     1                   -(sqrt((1.0/beta)+predvar(1:nop)))
         ebar(1,1:nop)=rop(1:nop,1)+((preddev(1,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)      
         ebar(2,1:nop)=rop(1:nop,1)+((preddev(2,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)      
         actval(1:nop)=rop(1:nop,1)+((testact(2,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1) 

         if (lscale.eq.1) then
            ebar(1,1:nop)=exp(ebar(1,1:nop))
            ebar(2,1:nop)=exp(ebar(2,1:nop))
            actval(1:nop)=exp(actval(1:nop))
         endif     
         write(41,12)ii,predip(ii,1:nip),
	1			actval(1:nop),ebar(1,1:nop),ebar(2,1:nop)
 5    continue       
 12   format(I5,1x,<nip>(F10.3,1x),1x,<3>(F10.3,1x))
 17   format(A10,2X,A16,I2,2X,A10,2X,A10,2X,A10) 
      
      close(41)      
100   return
      END SUBROUTINE unknownpred
c--------------------------------------------------------------------------