C-----------------------------------------------------------------
c     The back propagation feed forward operations are performed
c     in this subroutine in batch mode using the training data
C-----------------------------------------------------------------
	SUBROUTINE FFBP_BATCH
	INCLUDE 'header.txt'
	integer iter
	dimension act(5,nhid),dact(5,nhid),derr(nop),dact_in(nhid)
	dimension dact_out(nop),deltahid(nhid),deltaop(nop),err(nop)
	dimension err_mse(nop),fop(nop),testact(2,nhid+nop)
	dimension testsum(2,nhid+nop),sum1(2,ntrndat),sum2(ntrndat)
	dimension delta_wtih(nip,nhid),delta_wtho(nhid,nop)
	dimension delta_wtbh(nhid),delta_wtbo(1:nop)
     	dimension alphadelta_wtih(nip,nhid),alphadelta_wtho(nhid,nop)
     	dimension alphadelta_wtbh(nhid),alphadelta_wtbo(nop)
	real final_err,final_err_old,alpha1_new,beta_new
      iter=0
      final_err=100.0
	act(1:5,1:nhid)=0.0
	dact(1:5,1:nhid)=0.0
	err_mse(1:nop)=0.0
	derr(1:nop)=0.0
	err(1:nop)=0.0
	deltaop(1:nop)=0.0
	deltahid(1:nop)=0.0
	delta_wtbh(1:nhid)=0.0
	delta_wtho(1:nhid,1:nop)=0.0
	delta_wtih(1:nip,1:nhid)=0.0
	alphadelta_wtho(1:nhid,1:nop)=0.0
	alphadelta_wtih(1:nip,1:nhid)=0.0
	alphadelta_wtbh(1:nhid)=0.0
	fop(1:nop)=0.0
	sum1(1:2,1:ntrndat)=0.0
	sum2(1:ntrndat)=0.0
	testsum(1:2,1:nhid+nop)=0.0
	testact(1:2,1:nhid+nop)=0.0
	wtih(1:nip,1:nhid)=0.0
	wtho(1:nhid,1:nop)=0.0
	wtbh(1:30)=0.0
	train_err=0.0
	final_err_old=10.0
	alpha1_new=0.0
	beta_new=0.0	
	
	write(7,*)
	write(7,22)"NN_Architecture :",nip,"-",nhid,"-",nop
      write(7,*)
      write(7,*)"TRAINING OUTPUT"
     	write(7,*)
      write(7,17)"Dataset","Input","Desired","Predicted","Error"
     	write(7,*)
c	Generating weights by random number generator
c	Weights on connection from i/p nodes to h/d nodes
	icount=1
	do 115 i=1,nip
	   do 115 j=1,nhid
	      icount=icount+1
 10	      call random_number(rn)
	      if (rn.le.0.1) go to 10
	      wtih(i,j)=rn*((-1.0)**icount)
 115     continue
c	Weights on connection from h/d nodes to o/p nodes
	icount=1
	do 15 i=1,nhid
	   do 15 j=1,nop
	      icount=icount+1
 20	      call random_number(rn)
 	      if (rn.le.0.1) go to 20
	      wtho(i,j)=rn*((-1.0)**icount)
 15   continue
	if (nadbias.eq.1.0) then
         icount=1
	   do 25 i=1,nhid
	      icount=icount+1
 30	      call random_number(rn)
 	      if (rn.le.0.1) go to 30
	      wtbh(i)=rn*((-1.0)**icount)
 25      continue		   
	endif

c     weights are updated in batch mode based on the training data set
 	
	iter=0
	do 35 while ((final_err.gt.err_min).and.(iter.lt.iter_max))
	   iter=iter+1
	   delta_wtho(1:nhid,1:nop)=0.0
	   delta_wtih(1:nip,1:nhid)=0.0
	   delta_wtbh(1:nhid)=0.0 
	   final_err=0.0 	   	  	   
	   do 40 i=1,ntrndat
            do 45 j=1,nhid                   !loop over number of HN
			  sum1(1,j)=bias*wtbh(j)+sum(xnorm(i,1:nip)*wtih(1:nip,j))
			  if (inp_act.eq.1) then
			     act(1,j)=1/(1+exp(-sum1(1,j)))
			     dact(1,j)=act(1,j)*(1.0-act(1,j))
			  elseif (inp_act.eq.2) then
			     act(1,j)=(exp(sum1(1,j))-exp(-sum1(1,j)))
     1                    /(exp(sum1(1,j))+exp(-sum1(1,j)))
     			     dact(1,j)=1.0-(act(1,j)*act(1,j))
              endif
 45	      continue

c	Calculate Sum, OL output and Rate of change of OL output.

			do 50 j=1,nop                 !loop over number of ON
			   sum1(2,j)=sum(wtho(1:nhid,j)*act(1,1:nhid))
			   if (inp_act.eq.1) then
			      act(2,j)=1/(1+exp(-sum1(2,j)))
			      dact(2,j)=act(2,j)*(1.0-act(2,j))			    
			   elseif (inp_act.eq.2) then
			      act(2,j)=(exp(sum1(2,j))-exp(-sum1(2,j)))
     1                     /(exp(sum1(2,j))+exp(-sum1(2,j)))
			      dact(2,j)=1.0-(act(2,j)*act(2,j))     
               endif
 50		    continue

c     Back-propagation starts here derr() and err() are normalized 
c     and denormalized errors, respectively
								
		derr(1:nop)=ynorm(i,1:nop)-act(2,1:nop)
		final_err=final_err+sum((derr(1:nop)/act(2,1:nop))**2)
		deltaop(1:nop)=derr(1:nop)*dact(2,1:nop)       !error in ON
            do 55 k =1,nhid 
			   sum2(k)=sum(deltaop(1:nop)*wtho(k,1:nop))
 55         continue
            deltahid(1:nhid)=sum2(1:nhid)*dact(1,1:nhid)   !error in IN
            do 65 j=1,nhid
               delta_wtih(1:nip,j)=delta_wtih(1:nip,j)+
     1                             deltahid(j)*xnorm(i,1:nip)
               delta_wtbh(j)=delta_wtbh(j)+(deltahid(j)*bias)
			 delta_wtho(j,1:nop)=delta_wtho(j,1:nop)+
     1							 deltaop(1:nop)*act(1,j)
 65         continue
 40      continue
 
C	Calculation of Hessian Matrix & its inverse
		call HYPERPARAMETERS
		call AHESINV
		do 75 ir =1,nwts
			trace=trace+ahessianinv(ir,ir)
 75		continue

C	Updating Hyperparameters (Regularisers)
		gamma=(nwts)-alpha1*(trace)
		alpha1_new=(gamma)/(2.0*errorwt)
		beta_new=(ntrndat-gamma)/(2.0*errordata)
		alpha1=alpha1-eta*(alpha1-alpha1_new)
		beta=beta-eta*(beta-beta_new)
       
			
		final_err=sqrt(final_err/(ntrndat*nop)) !root mean square error
			if (final_err.gt.err_min) then 
		    do 70 j=1,nhid
				delta_wtih(1:nip,j)=(delta_wtih(1:nip,j))/ntrndat
				delta_wtbh(j)=delta_wtbh(j)/ntrndat
				delta_wtho(j,1:nop)=(delta_wtho(j,1:nop))/ntrndat	
			   		   			   
				wtih(1:nip,j)=wtih(1:nip,j)+eta*beta*delta_wtih(1:nip,j)
     1							-eta*alpha1*wtih(1:nip,j)/(nwts)
     1							-alpha*alphadelta_wtih(1:nip,j)     
     				wtbh(j)=wtbh(j)+eta*beta*delta_wtbh(j)
     1							-eta*alpha1*wtbh(j)/(nwts)
     1							-alpha*alphadelta_wtbh(j)     
				wtho(j,1:nop)=wtho(j,1:nop)+eta*beta*delta_wtho(j,1:nop)
     1				            -eta*alpha1*wtho(j,1:nop)/(nwts)  
     1							-alpha*alphadelta_wtho(j,1:nop)        
				alphadelta_wtih(1:nip,j)=eta*beta*delta_wtih(1:nip,j)
     1							-eta*alpha1*wtih(1:nip,j)/(nwts)  
				alphadelta_wtho(j,1:nop)=eta*beta*delta_wtho(j,1:nop)
     1							-eta*alpha1*wtho(j,1:nop)/(nwts)
				alphadelta_wtbh(j)=eta*beta*delta_wtbh(j)
     1							-eta*alpha1*wtbh(j)/(nwts)    
 70			continue 
			endif
 35	continue
             
c	testing for current input set with updated weights.

      do 80 i=1,ntrndat
         final_err=0.0
         do 85 j=1,nhid
		   testsum(1,j)=bias*wtbh(j)+sum(wtih(1:nip,j)*xnorm(i,1:nip))
		   if (inp_act.eq.1) then
		      testact(1,j)=1/(1+exp(-testsum(1,j)))
		   elseif (inp_act.eq.2) then
			  testact(1,j)=(exp(testsum(1,j))-exp(-testsum(1,j)))
     1                     /(exp(testsum(1,j))+exp(-testsum(1,j)))
		   endif
 85      continue
		 do 90 j=1,nop
	      testsum(2,j)=sum(wtho(1:nhid,j)*testact(1,1:nhid))
		    if (inp_act.eq.1) then
		       testact(2,j)=1/(1+exp(-testsum(2,j)))
		    elseif (inp_act.eq.2) then
			   testact(2,j)=(exp(testsum(2,j))-exp(-testsum(2,j)))
     1                      /(exp(testsum(2,j))+exp(-testsum(2,j)))
            endif		    
 90      continue
         fop(1:nop)=rop(1:nop,1)+((testact(2,1:nop)-znrm1)
     1             *(rop(1:nop,2)-rop(1:nop,1)))/(znrm2-znrm1)
          
c       final error calculations 

         if (lscale.eq.1) then   
            fop(1:nop)=exp(fop(1:nop))
            final_err=final_err+sum(EXP(yop(i,1:nop))-fop(1:nop))
            final_err=final_err/nop 
            write(7,12)i,xip(i,1:nip),
     1             exp(yop(i,1:nop)),(fop(1:nop)),final_err
            train_err=train_err+sum(abs((exp(yop(i,1:nop))
     1             -fop(1:nop)))/EXP(yop(i,1:nop)))
         else 
            final_err=final_err+sum(yop(i,1:nop)-fop(1:nop))
            final_err=final_err/nop 
            write(7,12)i,xip(i,1:nip),
     1              (yop(i,1:nop)),fop(1:nop),final_err
            train_err=train_err+sum(abs(((yop(i,1:nop))
     1                -fop(1:nop)))/yop(i,1:nop))
         endif         
 80	continue

C	Calculation of % error in training data
      train_err=100*(train_err/(ntrndat*nop))	
    
      write(7,*)      
 11   format(A15,3X,A16,5X,A16,1X,A14)
 12   format(I4,10x,<nip+nop*2+1>(F12.6,8x))
 16   format(I6,4x,<nip*nhid>(F12.6,1x))
 17   format(A10,15X,A10,19x,A10,12X,A10,10X,A10)
 14   format(I6,4x,<nhid*nop>(F12.6,1x))
 22   format(A17,1x,I2,1x,A2,1x,I2,1x,A2,1x,I2)
	return
	end	

c--------------------------------------------------------------
c     This subroutine uses the final weights and evaluate their
c     performance based on the testing data set	
C--------------------------------------------------------------
	SUBROUTINE TEST
	INCLUDE 'header.txt'
	dimension tact(5,nhid),fop(nop),err(nop),error(ntstdat)
	dimension tsum(5,nhid),testmin(10),testmax(10)
	real final_err
	test_err=0.0
	err(1:nop)=0.0
      error(1:ntstdat)=0.0
      fop(1:nop)=0.0
      tsum(1:5,1:nhid)=0.0
      tact(1:5,1:nhid)=0.0      
 
c     Normalization, calculation of sum and output at hidden and output
c	layers are dones using new weights. Final outputs are denormalized
c	and checked with actual outputs to estimate the training error
      
      write(7,*)"TESTING OUTPUT"
     	write(7,*)
      write(7,17)"Dataset","Inputs","Desired","Predicted","Error"
     	write(7,*)
	do 5 i=1,ntstdat
	fop(1:nop)=0.0
     		do 10 j=1,nhid
		    tsum(1,j)=bias*wtbh(j)+sum(wtih(1:nip,j)*testip(i,1:nip))
		    if (inp_act.eq.1) then
		       tact(1,j)=1/(1+exp(-tsum(1,j)))
		    elseif (inp_act.eq.2) then
		       tact(1,j)=(exp(tsum(1,j))-exp(-tsum(1,j)))
     1					/(exp(tsum(1,j))+exp(-tsum(1,j)))
			endif
 10		continue
		do 15 j=1,nop
		   tsum(2,j)=sum(wtho(1:nhid,j)*tact(1,1:nhid))
			if (inp_act.eq.1) then
				tact(2,j)=1/(1+exp(-tsum(2,j)))
			elseif (inp_act.eq.2) then
				tact(2,j)=(exp(tsum(2,j))-exp(-tsum(2,j)))
     1					 /(exp(tsum(2,j))+exp(-tsum(2,j)))
			endif
 15		continue
		fop(1:nop)=rop(1:nop,1)+((tact(2,1:nop)-znrm1)/(znrm2-znrm1))
     1							*(rop(1:nop,2)-rop(1:nop,1))     
         		        
		if (lscale.eq.1) then                   !de-logging of data
			fop(1:nop)=exp(fop(1:nop))
		endif
		test_err=test_err+sum(abs(((testop(i,1:nop)-fop(1:nop)))
     1                     /testop(i,1:nop)))     
		err(1:nop)=testop(i,1:nop)-fop(1:nop)
		error(i)=(sum(err(1:nop))/nop)
	write(7,12)i,atestip(i,1:nip),
     1			(testop(i,j),j=1,nop),(fop(j),j=1,nop),error(i)
 5	continue 

C	Calculation of % test error   
	test_err=100*(test_err/(ntstdat*nop))	    

 11   format(A15,3X,A16,5X,A16,1X,A14)
 12   format(I4,10x,<nip+nop*2+1>(F12.6,8x))
 17   format(A10,15X,A10,19x,A10,12X,A10,10X,A10)

	return
	end