c-----------------------------------------------------------------------
c	Neural Network code for 3 layer; Input, hidden, output;
c	with feed forward back propagation algorithm.
c-----------------------------------------------------------------------
      PROGRAM main
	INCLUDE 'header.txt'
	
	Dimension nhidf(40)
	integer negn,izz
	archi(1:30,1:5)=0.0
	archiwtih(1:30,1:10,1:30)=0.0
	archiwtho(1:30,1:30,1:10)=0.0
	archiwtbh(1:30,1:30)=0.0
	hyperpara(1:30,1:2)=0.0
	nhidf(1:40)=0
	
	write(*,*)"*****************************************************"
      write(*,*)"This ANN code is developed by Ms. Vinaya Manvatkar 
     1under" 
      write(*,*)"the guidance of Prof. Amitava De at Indian Institute" 
      write(*,*)"of Technology, Bombay. For any query kindly email to" 
      write(*,*)"vinayamanvatkar@gmail.com with cc to amit@iitb.ac.in"
      write(*,*)"******************************************************"
	call INPUT
	
	if((nsel.eq.1).OR.(nsel.eq.2))then
	open(7,FILE='architecture_outputs.txt')
	open(26,File='architecture_summary.txt')	
	
	endif

	if (nsel.eq.0) then
		go to 300
	endif

      if (nopfl.eq.1) then
		open (13,FILE='Al.txt',status="replace")
      else if (nopfl.eq.2)then
		open (13,FILE='Steel.txt',status="replace")
      endif
      
C ------------START OF LOOP FOR FORMATION OF DIFFERENT ARCHITECTURES-------------      

      icounter=0   
      minhid=nip
      maxhid=niphd*nip     

	do 5 nhid = minhid,maxhid
      	 icounter=icounter+1   
      	 
      	 alpha1=1.0
      	 beta=1.0     	 
             	       	 
      	 nwtih=nip*nhid
      	 nwtho=nhid*nop
      	 if(nadbias.eq.1)then
      	 nwtbh=nhid
      	 else
      	 nwtbh=0
      	 endif
      	 nwts=nwtbh+nwtih+nwtho  
      	 write(*,*)    	    	 
         write(*,*)"Training NN Network :",icounter
         write(*,*)"No. of Hidden nodes :", nhid
	   call FFBP_BATCH	   
	   write(*,*)"End of training"
	   write(*,*)
	   write(*,*)
	   call TEST
	   archiwtih(icounter,1:nip,1:nhid)=wtih(1:nip,1:nhid)
	   archiwtho(icounter,1:nhid,1:nop)=wtho(1:nhid,1:nop)
         archiwtbh(icounter,1:nhid)=wtbh(1:nhid)                  
	   archi(icounter,1)=nhid
	   archi(icounter,2)=train_err
	   archi(icounter,3)=test_err	   	   
	   errdat(icounter)=errordata
	   hyperpara(icounter,1)=alpha1
         hyperpara(icounter,2)=beta
     	   nnetwork=icounter 	
 	                   	     	
 5    continue
      write(26,*)"Architecture Summary"
      write(26,*)
	write(26,*)"Results for All Architectures"
	write(26,*)
      write(26,21)"Architecture"," % Training Error",
	1             " % Testing Error","alpha","beta"  
      write(26,*)
	do 40 i=1,nnetwork
	   write(26,16)i,archi(i,2),archi(i,3),hyperpara(i,1),
     1            hyperpara(i,2)	            
 40   continue
	
      call archcomp
      
      write(26,*)"Results for Selected Architectures"
      write(26,*)
      write(26,11)"Architecture","H/D nodes"," % Training Error",
	1             " % Testing Error","alpha","beta"  
	write(26,*)
	nhidf(1:jfinnet)=farchi(1:nfinnet,1)
	do 20 i=1,jfinnet
	   write(26,17)i,nhidf(i),farchi(i,2),farchi(i,3),
     1            fhyperpara(i,1),fhyperpara(i,2)	 
 20   continue
      icounter=0
      do 25 i=minhid,maxhid       
         icounter=icounter+1
         write(26,*)
	   write(26,12)"NN_Architecture",icounter,":",nip,"-",i,"-",nop	 
 25   continue
      hessian(1:500,1:500)=0.0
      ahessian(1:500,1:500)=0.0
      ahessianinv(1:500,1:500)=0.0
            
      call HYPERPARAMETERS    
      call AHESINV

	if((nopfl.eq.1).OR.(nopfl.eq.2))then
		do 35 i=1,nwts
		write(13,9)ahessianinv(i,1:nwts)
35		continue   
	endif

	If((nsel.eq.1).OR.(nsel.eq.2))then      
		call trainerrbar
		call testpred
	endif
      
300	If((nsel.eq.0).OR.(nsel.eq.2))then
		call unknownpred
	endif  

  9   format(<nwts>(F10.5,1x))       	           
 11   format(A15,6x,A10,5x,A12,5x,A10,3x,A10,5x,A10) 
 12   format(A20,1x,I2,2x,A2,2x,I2,1x,A2,1x,I2,1x,A2,1x,I2)
 16   format(4x,I2,14x,<4>(F12.6,4x))
 17   format(4x,I2,16x,I2,10x,<4>(F12.6,4x))
 18   format(A6,1x,I2,1x,A6,1x,<nip*nhid>(F12.6,1x)) 
 19   format(A6,4x,A6,1x,<nip*nhid>(F12.6,1x))
 21   format(A15,6x,A12,5x,A10,8x,A10,5x,A10)  	
 22   format(A20,1x,I2,1x,A2,1x,I2,1x,A2,1x,I2)	
	
	if ((nsel.eq.1).OR.(nsel.eq.2)) then
	   close(7)
	   close(13)
	   close(26)
	end if
	
	if(nsel.eq.0)then
	close(13)
	endif
      
      write(*,*)"Execution is complete, press Enter to exit"
      pause
      
	stop
	end